VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "UIState"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private controlData_ As Excel.Worksheet

Private Sub Class_Initialize()
  Set controlData_ = ThisWorkbook.Sheets(SHEET_UI)
End Sub

Public Function InputTargetFile()
  Call UpdateFileInCell(ThisWorkbook.Names(CELL_TARGET_PATH).RefersToRange)
End Function

Public Function InputTemplate()
  Call UpdateFileInCell(ThisWorkbook.Names(STYLE_TEMPLATE_NAME).RefersToRange)
End Function

Public Function ProduceRulesConfig() As API_Config
  Dim result As New API_Config
  Call result.SetValue("HighlightErrors", HighlightErrors)
  Call result.SetValue("CommentUnresolved", CommentUnresolved)
  Call result.SetValue("BannedWords", LoadBannedWords)
  Set ProduceRulesConfig = result
End Function

Public Function ChooseTargetFileFromOpened()
  '     
  On Error GoTo NO_APPLICATION
  Dim wordAppl As Word.Application: Set wordAppl = GetObject(, "Word.Application")
  
  Dim fileList As New Collection
  Dim nameList As New Collection
  Dim i&
  For i = 1 To wordAppl.Documents.Count
    Call fileList.Add(wordAppl.Documents.Item(i).FullName)
    Call nameList.Add(wordAppl.Documents.Item(i).Name)
  Next
  
  Call SelectSourceDlg.Init(nameList)
  SelectSourceDlg.Show
  If SelectSourceDlg.bCanceled Then _
    Exit Function
    
  ThisWorkbook.Names(CELL_TARGET_PATH).RefersToRange = fileList(SelectSourceDlg.GetSelectedID)
  
  Exit Function
  
NO_APPLICATION:
  Call UserInteraction.ShowMessage(EM_NO_OPEN_DOCS)
End Function

Public Function LogStylesData(nCount&, renames&, deletes&)
'    
  ThisWorkbook.Sheets(SHEET_UI).Range(STYLE_COUNT_NAME) = nCount
  ThisWorkbook.Sheets(SHEET_UI).Range(STYLE_DELETE_NAME) = deletes
  ThisWorkbook.Sheets(SHEET_UI).Range(STYLE_RENAME_NAME) = renames
End Function

' ========= Get ========
Public Property Get PageCount() As Long
  PageCount = ThisWorkbook.Names(CELL_PAGE_COUNT).RefersToRange
End Property

Public Property Get SingleRuleID() As String
  SingleRuleID = ThisWorkbook.Names(CELL_SINGLE_RULE).RefersToRange
End Property

Public Property Get ShowDiff() As Boolean
'  "  "
  ShowDiff = ThisWorkbook.Sheets(SHEET_UI).OptionDiff.Value
End Property

Public Property Get RevisionEnabled() As Boolean
'   "   "
  RevisionEnabled = ThisWorkbook.Sheets(SHEET_UI).OptionRevision.Value
End Property

Public Property Get CommentUnresolved() As Boolean
'   "    "
  CommentUnresolved = ThisWorkbook.Sheets(SHEET_UI).DoAddComment.Value
End Property

Public Property Get HighlightErrors() As Boolean
'   "   "
  HighlightErrors = ThisWorkbook.Sheets(SHEET_UI).DoHighlightCB.Value
End Property

Public Property Get DoDebug() As Boolean
  DoDebug = ThisWorkbook.Sheets(SHEET_UI).TurnOnDebug.Value
End Property

Public Property Get StylesDeleteUnused() As Boolean
  StylesDeleteUnused = ThisWorkbook.Sheets(SHEET_UI).DoDeleteUnused.Value
End Property

Public Property Get StylesRename() As Boolean
  StylesRename = ThisWorkbook.Sheets(SHEET_UI).DoRenameStyles.Value
End Property

Public Property Get StylesFormat() As Boolean
  StylesFormat = ThisWorkbook.Sheets(SHEET_UI).DoFormatStyles.Value
End Property

Public Property Get ErrorsCount() As Long
  Dim iCell As Excel.Range: Set iCell = ThisWorkbook.Names(CELL_ERROR_COUNT).RefersToRange
  Call iCell.Calculate
  ErrorsCount = iCell
End Property

Public Property Get FixesCount() As Long
  Dim iCell As Excel.Range: Set iCell = ThisWorkbook.Names(CELL_FIXES_COUNT).RefersToRange
  Call iCell.Calculate
  FixesCount = iCell
End Property

Public Property Get TargetPath() As String
  TargetPath = ThisWorkbook.Names(CELL_TARGET_PATH).RefersToRange
End Property

Public Property Get TemplatePath() As String
  Dim result$
  result = ThisWorkbook.Sheets(SHEET_UI).Range(STYLE_TEMPLATE_NAME)
  If VBA.Left(result, 9) Like "%APPDATA%" Then
    result = Environ("appdata") & VBA.Right(result, VBA.Len(result) - 9)
  End If
  TemplatePath = result
End Property

' ========= Let ========
Public Property Let PageCount(newVal&)
  ThisWorkbook.Names(CELL_PAGE_COUNT).RefersToRange = newVal
End Property

' ======
Private Function UpdateFileInCell(aCell As Excel.Range)
  Dim result$: result = UserInteraction.PromptFile(aCell.Text)
  If Not result = "" Then
    aCell = result
  End If
End Function
